require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FIDO_ERR_H)) {
    eval 'sub _FIDO_ERR_H () {1;}' unless defined(&_FIDO_ERR_H);
    eval 'sub FIDO_ERR_SUCCESS () {0x;}' unless defined(&FIDO_ERR_SUCCESS);
    eval 'sub FIDO_ERR_INVALID_COMMAND () {0x1;}' unless defined(&FIDO_ERR_INVALID_COMMAND);
    eval 'sub FIDO_ERR_INVALID_PARAMETER () {0x2;}' unless defined(&FIDO_ERR_INVALID_PARAMETER);
    eval 'sub FIDO_ERR_INVALID_LENGTH () {0x3;}' unless defined(&FIDO_ERR_INVALID_LENGTH);
    eval 'sub FIDO_ERR_INVALID_SEQ () {0x4;}' unless defined(&FIDO_ERR_INVALID_SEQ);
    eval 'sub FIDO_ERR_TIMEOUT () {0x5;}' unless defined(&FIDO_ERR_TIMEOUT);
    eval 'sub FIDO_ERR_CHANNEL_BUSY () {0x6;}' unless defined(&FIDO_ERR_CHANNEL_BUSY);
    eval 'sub FIDO_ERR_LOCK_REQUIRED () {0xa;}' unless defined(&FIDO_ERR_LOCK_REQUIRED);
    eval 'sub FIDO_ERR_INVALID_CHANNEL () {0xb;}' unless defined(&FIDO_ERR_INVALID_CHANNEL);
    eval 'sub FIDO_ERR_CBOR_UNEXPECTED_TYPE () {0x11;}' unless defined(&FIDO_ERR_CBOR_UNEXPECTED_TYPE);
    eval 'sub FIDO_ERR_INVALID_CBOR () {0x12;}' unless defined(&FIDO_ERR_INVALID_CBOR);
    eval 'sub FIDO_ERR_MISSING_PARAMETER () {0x14;}' unless defined(&FIDO_ERR_MISSING_PARAMETER);
    eval 'sub FIDO_ERR_LIMIT_EXCEEDED () {0x15;}' unless defined(&FIDO_ERR_LIMIT_EXCEEDED);
    eval 'sub FIDO_ERR_UNSUPPORTED_EXTENSION () {0x16;}' unless defined(&FIDO_ERR_UNSUPPORTED_EXTENSION);
    eval 'sub FIDO_ERR_FP_DATABASE_FULL () {0x17;}' unless defined(&FIDO_ERR_FP_DATABASE_FULL);
    eval 'sub FIDO_ERR_LARGEBLOB_STORAGE_FULL () {0x18;}' unless defined(&FIDO_ERR_LARGEBLOB_STORAGE_FULL);
    eval 'sub FIDO_ERR_CREDENTIAL_EXCLUDED () {0x19;}' unless defined(&FIDO_ERR_CREDENTIAL_EXCLUDED);
    eval 'sub FIDO_ERR_PROCESSING () {0x21;}' unless defined(&FIDO_ERR_PROCESSING);
    eval 'sub FIDO_ERR_INVALID_CREDENTIAL () {0x22;}' unless defined(&FIDO_ERR_INVALID_CREDENTIAL);
    eval 'sub FIDO_ERR_USER_ACTION_PENDING () {0x23;}' unless defined(&FIDO_ERR_USER_ACTION_PENDING);
    eval 'sub FIDO_ERR_OPERATION_PENDING () {0x24;}' unless defined(&FIDO_ERR_OPERATION_PENDING);
    eval 'sub FIDO_ERR_NO_OPERATIONS () {0x25;}' unless defined(&FIDO_ERR_NO_OPERATIONS);
    eval 'sub FIDO_ERR_UNSUPPORTED_ALGORITHM () {0x26;}' unless defined(&FIDO_ERR_UNSUPPORTED_ALGORITHM);
    eval 'sub FIDO_ERR_OPERATION_DENIED () {0x27;}' unless defined(&FIDO_ERR_OPERATION_DENIED);
    eval 'sub FIDO_ERR_KEY_STORE_FULL () {0x28;}' unless defined(&FIDO_ERR_KEY_STORE_FULL);
    eval 'sub FIDO_ERR_NOT_BUSY () {0x29;}' unless defined(&FIDO_ERR_NOT_BUSY);
    eval 'sub FIDO_ERR_NO_OPERATION_PENDING () {0x2a;}' unless defined(&FIDO_ERR_NO_OPERATION_PENDING);
    eval 'sub FIDO_ERR_UNSUPPORTED_OPTION () {0x2b;}' unless defined(&FIDO_ERR_UNSUPPORTED_OPTION);
    eval 'sub FIDO_ERR_INVALID_OPTION () {0x2c;}' unless defined(&FIDO_ERR_INVALID_OPTION);
    eval 'sub FIDO_ERR_KEEPALIVE_CANCEL () {0x2d;}' unless defined(&FIDO_ERR_KEEPALIVE_CANCEL);
    eval 'sub FIDO_ERR_NO_CREDENTIALS () {0x2e;}' unless defined(&FIDO_ERR_NO_CREDENTIALS);
    eval 'sub FIDO_ERR_USER_ACTION_TIMEOUT () {0x2f;}' unless defined(&FIDO_ERR_USER_ACTION_TIMEOUT);
    eval 'sub FIDO_ERR_NOT_ALLOWED () {0x30;}' unless defined(&FIDO_ERR_NOT_ALLOWED);
    eval 'sub FIDO_ERR_PIN_INVALID () {0x31;}' unless defined(&FIDO_ERR_PIN_INVALID);
    eval 'sub FIDO_ERR_PIN_BLOCKED () {0x32;}' unless defined(&FIDO_ERR_PIN_BLOCKED);
    eval 'sub FIDO_ERR_PIN_AUTH_INVALID () {0x33;}' unless defined(&FIDO_ERR_PIN_AUTH_INVALID);
    eval 'sub FIDO_ERR_PIN_AUTH_BLOCKED () {0x34;}' unless defined(&FIDO_ERR_PIN_AUTH_BLOCKED);
    eval 'sub FIDO_ERR_PIN_NOT_SET () {0x35;}' unless defined(&FIDO_ERR_PIN_NOT_SET);
    eval 'sub FIDO_ERR_PIN_REQUIRED () {0x36;}' unless defined(&FIDO_ERR_PIN_REQUIRED);
    eval 'sub FIDO_ERR_PIN_POLICY_VIOLATION () {0x37;}' unless defined(&FIDO_ERR_PIN_POLICY_VIOLATION);
    eval 'sub FIDO_ERR_PIN_TOKEN_EXPIRED () {0x38;}' unless defined(&FIDO_ERR_PIN_TOKEN_EXPIRED);
    eval 'sub FIDO_ERR_REQUEST_TOO_LARGE () {0x39;}' unless defined(&FIDO_ERR_REQUEST_TOO_LARGE);
    eval 'sub FIDO_ERR_ACTION_TIMEOUT () {0x3a;}' unless defined(&FIDO_ERR_ACTION_TIMEOUT);
    eval 'sub FIDO_ERR_UP_REQUIRED () {0x3b;}' unless defined(&FIDO_ERR_UP_REQUIRED);
    eval 'sub FIDO_ERR_UV_BLOCKED () {0x3c;}' unless defined(&FIDO_ERR_UV_BLOCKED);
    eval 'sub FIDO_ERR_UV_INVALID () {0x3f;}' unless defined(&FIDO_ERR_UV_INVALID);
    eval 'sub FIDO_ERR_UNAUTHORIZED_PERM () {0x40;}' unless defined(&FIDO_ERR_UNAUTHORIZED_PERM);
    eval 'sub FIDO_ERR_ERR_OTHER () {0x7f;}' unless defined(&FIDO_ERR_ERR_OTHER);
    eval 'sub FIDO_ERR_SPEC_LAST () {0xdf;}' unless defined(&FIDO_ERR_SPEC_LAST);
    eval 'sub FIDO_OK () { &FIDO_ERR_SUCCESS;}' unless defined(&FIDO_OK);
    eval 'sub FIDO_ERR_TX () {-1;}' unless defined(&FIDO_ERR_TX);
    eval 'sub FIDO_ERR_RX () {-2;}' unless defined(&FIDO_ERR_RX);
    eval 'sub FIDO_ERR_RX_NOT_CBOR () {-3;}' unless defined(&FIDO_ERR_RX_NOT_CBOR);
    eval 'sub FIDO_ERR_RX_INVALID_CBOR () {-4;}' unless defined(&FIDO_ERR_RX_INVALID_CBOR);
    eval 'sub FIDO_ERR_INVALID_PARAM () {-5;}' unless defined(&FIDO_ERR_INVALID_PARAM);
    eval 'sub FIDO_ERR_INVALID_SIG () {-6;}' unless defined(&FIDO_ERR_INVALID_SIG);
    eval 'sub FIDO_ERR_INVALID_ARGUMENT () {-7;}' unless defined(&FIDO_ERR_INVALID_ARGUMENT);
    eval 'sub FIDO_ERR_USER_PRESENCE_REQUIRED () {-8;}' unless defined(&FIDO_ERR_USER_PRESENCE_REQUIRED);
    eval 'sub FIDO_ERR_INTERNAL () {-9;}' unless defined(&FIDO_ERR_INTERNAL);
    eval 'sub FIDO_ERR_NOTFOUND () {-10;}' unless defined(&FIDO_ERR_NOTFOUND);
    eval 'sub FIDO_ERR_COMPRESS () {-11;}' unless defined(&FIDO_ERR_COMPRESS);
    if(defined(&__cplusplus)) {
    }
    if(defined(&__cplusplus)) {
    }
}
1;
