require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ASM_H_)) {
    eval 'sub _ASM_H_ () {1;}' unless defined(&_ASM_H_);
    unless(defined(&_LOCORE)) {
	eval 'sub _LOCORE () {1;}' unless defined(&_LOCORE);
    }
    require 'machine/frame.ph';
    if(defined(&__ELF__)) {
	eval 'sub _C_LABEL {
	    my($name) = @_;
    	    eval q($name);
	}' unless defined(&_C_LABEL);
    } else {
	if(defined(&__STDC__)) {
	    eval 'sub _C_LABEL {
	        my($name) = @_;
    		eval q( &_  $name);
	    }' unless defined(&_C_LABEL);
	} else {
	    eval 'sub _C_LABEL {
	        my($name) = @_;
    		eval q( &_ $name);
	    }' unless defined(&_C_LABEL);
	}
    }
    eval 'sub _ASM_LABEL {
        my($name) = @_;
	    eval q($name);
    }' unless defined(&_ASM_LABEL);
    if(defined(&__PIC__)) {
	if(defined(&__arch64__)) {
	    eval 'sub PIC_PROLOGUE {
	        my($dest,$tmp) = @_;
    		eval q( &mov % &o7, $tmp;  &sethi % &hi( &_GLOBAL_OFFSET_TABLE_-4),$dest;  &call 0 &f;  &or $dest,% &lo( &_GLOBAL_OFFSET_TABLE_+4),$dest; 0:  &add $dest,% &o7,$dest;  &mov $tmp, % &o7);
	    }' unless defined(&PIC_PROLOGUE);
	} else {
	    eval 'sub PIC_PROLOGUE {
	        my($dest,$tmp) = @_;
    		eval q( &mov % &o7,$tmp; 3:  &call 4 &f;  &nop; 4:  &sethi % &hi( &_C_LABEL( &_GLOBAL_OFFSET_TABLE_)-(3 &b-.)),$dest;  &or $dest,% &lo( &_C_LABEL( &_GLOBAL_OFFSET_TABLE_)-(3 &b-.)),$dest;  &add $dest,% &o7,$dest;  &mov $tmp,% &o7);
	    }' unless defined(&PIC_PROLOGUE);
	}
	if(defined(&__arch64__)) {
	    eval 'sub PICCY_SET {
	        my($var,$dest,$tmp) = @_;
    		eval q(3:  &rd % &pc, $tmp;  &add $tmp,($var-3 &b),$dest);
	    }' unless defined(&PICCY_SET);
	} else {
	    eval 'sub PICCY_SET {
	        my($var,$dest,$tmp) = @_;
    		eval q( &mov % &o7,$tmp; 3:  &call 4 &f;  &nop; 4:  &add % &o7,($var-3 &b),$dest;  &mov $tmp,% &o7);
	    }' unless defined(&PICCY_SET);
	}
    } else {
	eval 'sub PIC_PROLOGUE {
	    my($dest,$tmp) = @_;
    	    eval q();
	}' unless defined(&PIC_PROLOGUE);
	eval 'sub PICCY_OFFSET {
	    my($var,$dest,$tmp) = @_;
    	    eval q();
	}' unless defined(&PICCY_OFFSET);
    }
    eval 'sub FTYPE {
        my($x) = @_;
	    eval q(. &type $x,@ &function);
    }' unless defined(&FTYPE);
    eval 'sub OTYPE {
        my($x) = @_;
	    eval q(. &type $x,@ &object);
    }' unless defined(&OTYPE);
    eval 'sub _ENTRY {
        my($name) = @_;
	    eval q(. &align 4; . &globl $name;  &FTYPE($name); $name:);
    }' unless defined(&_ENTRY);
    if(defined(&GPROF)) {
	if(defined(&__ELF__)) {
	    if(defined(&__arch64__)) {
		eval 'sub _PROF_PROLOGUE () {. &data; . &align 8; 1: . &word 0; . &word 0; . &text;  &save % &sp,- &CC64FSZ,% &sp;  &sethi % &hi(1 &b),% &o0;  &call  &_mcount;  &or % &o0,% &lo(1 &b),% &o0;  &restore;}' unless defined(&_PROF_PROLOGUE);
	    } else {
		eval 'sub _PROF_PROLOGUE () {. &data; . &align 4; 1: .\'long 0\'; . &text;  &save % &sp,-96,% &sp;  &sethi % &hi(1 &b),% &o0;  &call  &_mcount;  &or % &o0,% &lo(1 &b),% &o0;  &restore;}' unless defined(&_PROF_PROLOGUE);
	    }
	} else {
	    if(defined(&__arch64__)) {
		eval 'sub _PROF_PROLOGUE () {. &data; . &align 8; 1: . &word 0; . &word 0; . &text;  &save % &sp,- &CC64FSZ,% &sp;  &sethi % &hi(1 &b),% &o0;  &call  &mcount;  &or % &o0,% &lo(1 &b),% &o0;  &restore;}' unless defined(&_PROF_PROLOGUE);
	    } else {
		eval 'sub _PROF_PROLOGUE () {. &data; . &align 4; 1: .\'long 0\'; . &text;  &save % &sp,-96,% &sp;  &sethi % &hi(1 &b),% &o0;  &call  &mcount;  &or % &o0,% &lo(1 &b),% &o0;  &restore;}' unless defined(&_PROF_PROLOGUE);
	    }
	}
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub ENTRY {
        my($name) = @_;
	    eval q( &_ENTRY( &_C_LABEL($name));  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub ENTRY_NOPROFILE {
        my($name) = @_;
	    eval q( &_ENTRY( &_C_LABEL($name)));
    }' unless defined(&ENTRY_NOPROFILE);
    eval 'sub ASENTRY {
        my($name) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($name));  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub FUNC {
        my($name) = @_;
	    eval q( &ASENTRY($name));
    }' unless defined(&FUNC);
    eval 'sub RODATA {
        my($name) = @_;
	    eval q(. &align 4; . &text; . &globl  &_C_LABEL($name);  &OTYPE( &_C_LABEL($name));  &_C_LABEL($name):);
    }' unless defined(&RODATA);
    eval 'sub END {
        my($y) = @_;
	    eval q(. &size $y, . - $y);
    }' unless defined(&END);
    eval 'sub ASMSTR () {. &asciz;}' unless defined(&ASMSTR);
    if(defined(&__ELF__)) {
	eval 'sub RCSID {
	    my($x) = @_;
    	    eval q(. &pushsection \\".ident\\",\\"MS\\",@ &progbits,1; . &asciz $x; . &popsection);
	}' unless defined(&RCSID);
    } else {
	eval 'sub RCSID {
	    my($name) = @_;
    	    eval q(. &asciz $name);
	}' unless defined(&RCSID);
    }
    if(defined(&NO_KERNEL_RCSIDS)) {
	eval 'sub __KERNEL_RCSID {
	    my($_n, $_s) = @_;
    	    eval q();
	}' unless defined(&__KERNEL_RCSID);
    } else {
	eval 'sub __KERNEL_RCSID {
	    my($_n, $_s) = @_;
    	    eval q( &RCSID($_s));
	}' unless defined(&__KERNEL_RCSID);
    }
    if(defined(&__ELF__)) {
	eval 'sub WEAK_ALIAS {
	    my($alias,$sym) = @_;
    	    eval q(. &weak $alias; $alias = $sym);
	}' unless defined(&WEAK_ALIAS);
    }
    eval 'sub STRONG_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &globl $alias; $alias = $sym);
    }' unless defined(&STRONG_ALIAS);
    if(defined(&__ELF__)) {
	if(defined(&__STDC__)) {
	    eval 'sub WARN_REFERENCES {
	        my($sym,$msg) = @_;
    		eval q(. &pushsection . ($gnu->{warning}).  $sym; . &ascii $msg; . &popsection);
	    }' unless defined(&WARN_REFERENCES);
	} else {
	    eval 'sub WARN_REFERENCES {
	        my($sym,$msg) = @_;
    		eval q(. &pushsection . ($gnu->{warning}). $sym; . &ascii $msg; . &popsection);
	    }' unless defined(&WARN_REFERENCES);
	}
    } else {
	if(defined(&__STDC__)) {
	    eval 'sub __STRING {
	        my($x) = @_;
    		eval q($x);
	    }' unless defined(&__STRING);
	    eval 'sub WARN_REFERENCES {
	        my($sym,$msg) = @_;
    		eval q(. &stabs $msg  ,30,0,0,0; . &stabs  &__STRING( &_  $sym)  ,1,0,0,0);
	    }' unless defined(&WARN_REFERENCES);
	} else {
	    eval 'sub __STRING {
	        my($x) = @_;
    		eval q(\\"x\\");
	    }' unless defined(&__STRING);
	    eval 'sub WARN_REFERENCES {
	        my($sym,$msg) = @_;
    		eval q(. &stabs $msg,30,0,0,0; . &stabs  &__STRING( &_ $sym),1,0,0,0);
	    }' unless defined(&WARN_REFERENCES);
	}
    }
    if(defined(&__arch64__)) {
	eval 'sub INCR64X {
	    my($what,$r0,$r1) = @_;
    	    eval q( &sethi % &hi($what), $r0;  &ldx [$r0 + % &lo($what)], $r1;  &inc $r1;  &stx $r1, [$r0 + % &lo($what)]);
	}' unless defined(&INCR64X);
	eval 'sub INCR64 {
	    my($what) = @_;
    	    eval q( &INCR64X($what,% &o0,% &o1));
	}' unless defined(&INCR64);
    } else {
	eval 'sub INCR64X {
	    my($what,$r0,$r1,$r2) = @_;
    	    eval q( &sethi % &hi($what), $r2;  &ldd [$r2 + % &lo($what)], $r0;  &inccc $r1;  &addx $r0, 0, $r0;  &std $r0, [$r2 + % &lo($what)]);
	}' unless defined(&INCR64X);
	eval 'sub INCR64 {
	    my($what) = @_;
    	    eval q( &INCR64X($what,% &o0,% &o1,% &l7));
	}' unless defined(&INCR64);
    }
}
1;
