require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PTE_H_)) {
    eval 'sub _MACHINE_PTE_H_ () {1;}' unless defined(&_MACHINE_PTE_H_);
    if(defined(&_KERNEL_OPT)) {
	require './sparc64/opt_sparc_arch.ph';
    }
    eval 'sub VA_SUN4_VPG {
        my($va) = @_;
	    eval q(((($va) >> 13) & 31));
    }' unless defined(&VA_SUN4_VPG);
    eval 'sub VA_SUN4C_VPG {
        my($va) = @_;
	    eval q(((($va) >> 12) & 63));
    }' unless defined(&VA_SUN4C_VPG);
    eval 'sub VA_SUN4U_VPG {
        my($va) = @_;
	    eval q(((($va) >> 13) & 31));
    }' unless defined(&VA_SUN4U_VPG);
    eval 'sub VA_SUN4_OFF {
        my($va) = @_;
	    eval q(((($va)) & 0x1fff));
    }' unless defined(&VA_SUN4_OFF);
    eval 'sub VA_SUN4C_OFF {
        my($va) = @_;
	    eval q(((($va)) & 0xfff));
    }' unless defined(&VA_SUN4C_OFF);
    eval 'sub VA_SUN4U_OFF {
        my($va) = @_;
	    eval q(((($va)) & 0x1fff));
    }' unless defined(&VA_SUN4U_OFF);
    eval 'sub VA_VPG {
        my($va) = @_;
	    eval q( &VA_SUN4U_VPG($va));
    }' unless defined(&VA_VPG);
    eval 'sub VA_OFF {
        my($va) = @_;
	    eval q( &VA_SUN4U_OFF($va));
    }' unless defined(&VA_OFF);
    eval 'sub PG_SHIFT4U () {13;}' unless defined(&PG_SHIFT4U);
    eval 'sub MMU_PAGE_ALIGN () {8192;}' unless defined(&MMU_PAGE_ALIGN);
    eval 'sub TSBVA {
        my($i) = @_;
	    eval q((( ($tsb[&(i)]->{tag}->{f}->{tag_va})<<22)|((($i)<<13)&0x3ff000)));
    }' unless defined(&TSBVA);
    unless(defined(&_LOCORE)) {
	if(0) {
	} else {
	}
    }
    eval 'sub CTX_MASK () {((1<<13)-1);}' unless defined(&CTX_MASK);
    eval 'sub TSB_TAG_CTX_SHIFT () {48;}' unless defined(&TSB_TAG_CTX_SHIFT);
    eval 'sub TSB_TAG_VA_SHIFT () {22;}' unless defined(&TSB_TAG_VA_SHIFT);
    eval 'sub TSB_TAG_G () {9.22337203685478e+18;}' unless defined(&TSB_TAG_G);
    eval 'sub TSB_TAG_CTX {
        my($t) = @_;
	    eval q((((( &int64_t)($t))>> &TSB_TAG_CTX_SHIFT) &CTX_MASK));
    }' unless defined(&TSB_TAG_CTX);
    eval 'sub TSB_TAG_VA {
        my($t) = @_;
	    eval q((((( &int64_t)($t))<< &TSB_TAG_VA_SHIFT)));
    }' unless defined(&TSB_TAG_VA);
    eval 'sub TSB_TAG {
        my($g,$ctx,$va) = @_;
	    eval q((((( &uint64_t)(($g)!=0))<<63)|((( &uint64_t)($ctx) &CTX_MASK)<< &TSB_TAG_CTX_SHIFT)|((( &uint64_t)$va)>> &TSB_TAG_VA_SHIFT)));
    }' unless defined(&TSB_TAG);
    eval 'sub PGSZ_8K () {0;}' unless defined(&PGSZ_8K);
    eval 'sub PGSZ_64K () {1;}' unless defined(&PGSZ_64K);
    eval 'sub PGSZ_512K () {2;}' unless defined(&PGSZ_512K);
    eval 'sub PGSZ_4M () {3;}' unless defined(&PGSZ_4M);
    eval 'sub SUN4U_PGSZ_SHIFT () {61;}' unless defined(&SUN4U_PGSZ_SHIFT);
    eval 'sub SUN4U_TLB_SZ {
        my($s) = @_;
	    eval q(((( &uint64_t)($s))<< &SUN4U_PGSZ_SHIFT));
    }' unless defined(&SUN4U_TLB_SZ);
    eval 'sub SUN4U_TLB_V () {9.22337203685478e+18;}' unless defined(&SUN4U_TLB_V);
    eval 'sub SUN4U_TLB_8K () { &SUN4U_TLB_SZ( &PGSZ_8K);}' unless defined(&SUN4U_TLB_8K);
    eval 'sub SUN4U_TLB_64K () { &SUN4U_TLB_SZ( &PGSZ_64K);}' unless defined(&SUN4U_TLB_64K);
    eval 'sub SUN4U_TLB_512K () { &SUN4U_TLB_SZ( &PGSZ_512K);}' unless defined(&SUN4U_TLB_512K);
    eval 'sub SUN4U_TLB_4M () { &SUN4U_TLB_SZ( &PGSZ_4M);}' unless defined(&SUN4U_TLB_4M);
    eval 'sub SUN4U_TLB_SZ_MASK () {6.91752902764108e+18;}' unless defined(&SUN4U_TLB_SZ_MASK);
    eval 'sub SUN4U_TLB_NFO () {1.15292150460685e+18;}' unless defined(&SUN4U_TLB_NFO);
    eval 'sub SUN4U_TLB_IE () {5.76460752303423e+17;}' unless defined(&SUN4U_TLB_IE);
    eval 'sub SUN4U_TLB_SOFT2_MASK () {5.75334852396581e+17;}' unless defined(&SUN4U_TLB_SOFT2_MASK);
    eval 'sub SUN4U_TLB_RESERVED_MASK () {1.11710381382042e+15;}' unless defined(&SUN4U_TLB_RESERVED_MASK);
    eval 'sub SUN4U_TLB_PA_MASK () {8796093014016;}' unless defined(&SUN4U_TLB_PA_MASK);
    eval 'sub SUN4U_TLB_SOFT_MASK () {0x1f80;}' unless defined(&SUN4U_TLB_SOFT_MASK);
    eval 'sub SUN4U_TLB_ACCESS () {0x200;}' unless defined(&SUN4U_TLB_ACCESS);
    eval 'sub SUN4U_TLB_MODIFY () {0x800;}' unless defined(&SUN4U_TLB_MODIFY);
    eval 'sub SUN4U_TLB_REAL_W () {0x400;}' unless defined(&SUN4U_TLB_REAL_W);
    eval 'sub SUN4U_TLB_TSB_LOCK () {0x1000;}' unless defined(&SUN4U_TLB_TSB_LOCK);
    eval 'sub SUN4U_TLB_EXEC () {0x100;}' unless defined(&SUN4U_TLB_EXEC);
    eval 'sub SUN4U_TLB_EXEC_ONLY () {0x80;}' unless defined(&SUN4U_TLB_EXEC_ONLY);
    eval 'sub SUN4U_TLB_L () {0x40;}' unless defined(&SUN4U_TLB_L);
    eval 'sub SUN4U_TLB_CACHE_MASK () {0x30;}' unless defined(&SUN4U_TLB_CACHE_MASK);
    eval 'sub SUN4U_TLB_CP () {0x20;}' unless defined(&SUN4U_TLB_CP);
    eval 'sub SUN4U_TLB_CV () {0x10;}' unless defined(&SUN4U_TLB_CV);
    eval 'sub SUN4U_TLB_E () {0x8;}' unless defined(&SUN4U_TLB_E);
    eval 'sub SUN4U_TLB_P () {0x4;}' unless defined(&SUN4U_TLB_P);
    eval 'sub SUN4U_TLB_W () {0x2;}' unless defined(&SUN4U_TLB_W);
    eval 'sub SUN4U_TLB_G () {0x1;}' unless defined(&SUN4U_TLB_G);
    eval 'sub TLB_WIRED () {4.5035996273705e+15;}' unless defined(&TLB_WIRED);
    eval 'sub SUN4U_TTE_ACCESS () {0x200;}' unless defined(&SUN4U_TTE_ACCESS);
    eval 'sub SUN4U_TTE_MODIFY () {0x800;}' unless defined(&SUN4U_TTE_MODIFY);
    eval 'sub SUN4U_TTE_REAL_W () {0x400;}' unless defined(&SUN4U_TTE_REAL_W);
    eval 'sub SUN4U_TTE_TSB_LOCK () {0x1000;}' unless defined(&SUN4U_TTE_TSB_LOCK);
    eval 'sub SUN4U_TTE_EXEC () {0x100;}' unless defined(&SUN4U_TTE_EXEC);
    eval 'sub SUN4U_TTE_EXEC_ONLY () {0x80;}' unless defined(&SUN4U_TTE_EXEC_ONLY);
    eval 'sub SUN4U_TTE_L () {0x40;}' unless defined(&SUN4U_TTE_L);
    eval 'sub SUN4U_TTE_CACHE_MASK () {0x30;}' unless defined(&SUN4U_TTE_CACHE_MASK);
    eval 'sub SUN4U_TTE_CP () {0x20;}' unless defined(&SUN4U_TTE_CP);
    eval 'sub SUN4U_TTE_CV () {0x10;}' unless defined(&SUN4U_TTE_CV);
    eval 'sub SUN4U_TTE_E () {0x8;}' unless defined(&SUN4U_TTE_E);
    eval 'sub SUN4U_TTE_P () {0x4;}' unless defined(&SUN4U_TTE_P);
    eval 'sub SUN4U_TTE_W () {0x2;}' unless defined(&SUN4U_TTE_W);
    eval 'sub SUN4U_TTE_G () {0x1;}' unless defined(&SUN4U_TTE_G);
    eval 'sub TTE_DATA_BITS () {"\\177\\20" "b\\77V\\0" "f\\75\\2SIZE\\0" "b\\77V\\0" "f\\75\\2SIZE\\0" "=\\0008K\\0" "=\\00164K\\0" "=\\002512K\\0" "=\\0034M\\0" "b\\74NFO\\0" "b\\73IE\\0" "f\\62\\10SOFT2\\0" "f\\51\\10DIAG\\0" "f\\15\\33PA<40:13>\\0" "f\\7\\5SOFT\\0" "b\\6L\\0" "b\\5CP\\0" "b\\4CV\\0" "b\\3E\\0" "b\\2P\\0" "b\\1W\\0" "b\\0G\\0";}' unless defined(&TTE_DATA_BITS);
    eval 'sub SUN4V_PGSZ_SHIFT () {0;}' unless defined(&SUN4V_PGSZ_SHIFT);
    eval 'sub SUN4V_TLB_SZ {
        my($s) = @_;
	    eval q(((( &uint64_t)($s))<< &SUN4V_PGSZ_SHIFT));
    }' unless defined(&SUN4V_TLB_SZ);
    eval 'sub SUN4V_TLB_V () {9.22337203685478e+18;}' unless defined(&SUN4V_TLB_V);
    eval 'sub SUN4V_TLB_8K () { &SUN4V_TLB_SZ( &PGSZ_8K);}' unless defined(&SUN4V_TLB_8K);
    eval 'sub SUN4V_TLB_64K () { &SUN4V_TLB_SZ( &PGSZ_64K);}' unless defined(&SUN4V_TLB_64K);
    eval 'sub SUN4V_TLB_512K () { &SUN4V_TLB_SZ( &PGSZ_512K);}' unless defined(&SUN4V_TLB_512K);
    eval 'sub SUN4V_TLB_4M () { &SUN4V_TLB_SZ( &PGSZ_4M);}' unless defined(&SUN4V_TLB_4M);
    eval 'sub SUN4V_TLB_SZ_MASK () {0xf;}' unless defined(&SUN4V_TLB_SZ_MASK);
    eval 'sub SUN4V_TLB_NFO () {4.61168601842739e+18;}' unless defined(&SUN4V_TLB_NFO);
    eval 'sub SUN4V_TLB_IE () {0x1000;}' unless defined(&SUN4V_TLB_IE);
    eval 'sub SUN4V_TLB_SOFT2_MASK () {4.53962842438946e+18;}' unless defined(&SUN4V_TLB_SOFT2_MASK);
    eval 'sub SUN4V_TLB_PA_MASK () {7.20575940379197e+16;}' unless defined(&SUN4V_TLB_PA_MASK);
    eval 'sub SUN4V_TLB_SOFT_MASK () {0x30;}' unless defined(&SUN4V_TLB_SOFT_MASK);
    eval 'sub SUN4V_TLB_ACCESS () {0x10;}' unless defined(&SUN4V_TLB_ACCESS);
    eval 'sub SUN4V_TLB_MODIFY () {0x20;}' unless defined(&SUN4V_TLB_MODIFY);
    eval 'sub SUN4V_TLB_REAL_W () {2.30584300921369e+18;}' unless defined(&SUN4V_TLB_REAL_W);
    eval 'sub SUN4V_TLB_TSB_LOCK () {1.15292150460685e+18;}' unless defined(&SUN4V_TLB_TSB_LOCK);
    eval 'sub SUN4V_TLB_EXEC () { &SUN4V_TLB_X;}' unless defined(&SUN4V_TLB_EXEC);
    eval 'sub SUN4V_TLB_EXEC_ONLY () {1.44115188075856e+17;}' unless defined(&SUN4V_TLB_EXEC_ONLY);
    eval 'sub SUN4V_TLB_CACHE_MASK () {0x600;}' unless defined(&SUN4V_TLB_CACHE_MASK);
    eval 'sub SUN4V_TLB_CP () {0x400;}' unless defined(&SUN4V_TLB_CP);
    eval 'sub SUN4V_TLB_CV () {0x200;}' unless defined(&SUN4V_TLB_CV);
    eval 'sub SUN4V_TLB_E () {0x800;}' unless defined(&SUN4V_TLB_E);
    eval 'sub SUN4V_TLB_P () {0x100;}' unless defined(&SUN4V_TLB_P);
    eval 'sub SUN4V_TLB_X () {0x80;}' unless defined(&SUN4V_TLB_X);
    eval 'sub SUN4V_TLB_W () {0x40;}' unless defined(&SUN4V_TLB_W);
    eval 'sub SUN4V_TLB_G () {0x;}' unless defined(&SUN4V_TLB_G);
    eval 'sub SUN4U_TSB_DATA {
        my($g,$sz,$pa,$priv,$write,$cache,$aliased,$valid,$ie,$wc) = @_;
	    eval q(((($valid)? &SUN4U_TLB_V:0)| &SUN4U_TLB_SZ($sz)|((( &uint64_t)($pa)) &SUN4U_TLB_PA_MASK)|(($cache)?(($aliased)? &SUN4U_TLB_CP: &SUN4U_TLB_CACHE_MASK):(($wc)?0: &SUN4U_TLB_E))|(($priv)? &SUN4U_TLB_P:0)|(($write)? &SUN4U_TLB_W:0)|(($g)? &SUN4U_TLB_G:0)|(($ie)? &SUN4U_TLB_IE:0)));
    }' unless defined(&SUN4U_TSB_DATA);
    eval 'sub SUN4V_TSB_DATA {
        my($g,$sz,$pa,$priv,$write,$cache,$aliased,$valid,$ie,$wc) = @_;
	    eval q(((($valid)? &SUN4V_TLB_V:0)| &SUN4V_TLB_SZ($sz)|((( &u_int64_t)($pa)) &SUN4V_TLB_PA_MASK)|(($cache)?(($aliased)? &SUN4V_TLB_CP: &SUN4V_TLB_CACHE_MASK):(($wc)?0: &SUN4V_TLB_E))|(($priv)? &SUN4V_TLB_P:0)|(($write)? &SUN4V_TLB_W:0)|(($g)? &SUN4V_TLB_G:0)|(($ie)? &SUN4V_TLB_IE:0)));
    }' unless defined(&SUN4V_TSB_DATA);
    eval 'sub TSB_DATA {
        my($g,$sz,$pa,$priv,$write,$cache,$aliased,$valid,$ie,$wc) = @_;
	    eval q(( &CPU_ISSUN4V ?  &SUN4V_TSB_DATA($g,$sz,$pa,$priv,$write,$cache,$aliased,$valid,$ie,$wc) :  &SUN4U_TSB_DATA($g,$sz,$pa,$priv,$write,$cache,$aliased,$valid,$ie,$wc)));
    }' unless defined(&TSB_DATA);
    eval 'sub TLB_EXEC () {( &CPU_ISSUN4V ?  &SUN4V_TLB_EXEC :  &SUN4U_TLB_EXEC);}' unless defined(&TLB_EXEC);
    eval 'sub TLB_V () {( &CPU_ISSUN4V ?  &SUN4V_TLB_V :  &SUN4U_TLB_V);}' unless defined(&TLB_V);
    eval 'sub TLB_PA_MASK () {( &CPU_ISSUN4V ?  &SUN4V_TLB_PA_MASK :  &SUN4U_TLB_PA_MASK);}' unless defined(&TLB_PA_MASK);
    eval 'sub TLB_CP () {( &CPU_ISSUN4V ?  &SUN4V_TLB_CP :  &SUN4U_TLB_CP);}' unless defined(&TLB_CP);
    eval 'sub TLB_P () {( &CPU_ISSUN4V ?  &SUN4V_TLB_P :  &SUN4U_TLB_P);}' unless defined(&TLB_P);
    eval 'sub TLB_W () {( &CPU_ISSUN4V ?  &SUN4V_TLB_W :  &SUN4U_TLB_W);}' unless defined(&TLB_W);
    eval 'sub TLB_ACCESS () {( &CPU_ISSUN4V ?  &SUN4V_TLB_ACCESS :  &SUN4U_TLB_ACCESS);}' unless defined(&TLB_ACCESS);
    eval 'sub TLB_MODIFY () {( &CPU_ISSUN4V ?  &SUN4V_TLB_MODIFY :  &SUN4U_TLB_MODIFY);}' unless defined(&TLB_MODIFY);
    eval 'sub TLB_REAL_W () {( &CPU_ISSUN4V ?  &SUN4V_TLB_REAL_W :  &SUN4U_TLB_REAL_W);}' unless defined(&TLB_REAL_W);
    eval 'sub TLB_TSB_LOCK () {( &CPU_ISSUN4V ?  &SUN4V_TLB_TSB_LOCK :  &SUN4U_TLB_TSB_LOCK);}' unless defined(&TLB_TSB_LOCK);
    eval 'sub TLB_EXEC_ONLY () {( &CPU_ISSUN4V ?  &SUN4V_TLB_EXEC_ONLY :  &SUN4U_TLB_EXEC_ONLY);}' unless defined(&TLB_EXEC_ONLY);
    eval 'sub TLB_L () {( &CPU_ISSUN4V ? 0:  &SUN4U_TLB_L);}' unless defined(&TLB_L);
    eval 'sub TLB_CV () {( &CPU_ISSUN4V ?  &SUN4V_TLB_CV :  &SUN4U_TLB_CV);}' unless defined(&TLB_CV);
    eval 'sub TLB_IE () {( &CPU_ISSUN4V ?  &SUN4V_TLB_IE :  &SUN4U_TLB_IE);}' unless defined(&TLB_IE);
    eval 'sub MMU_CACHE_VIRT () {0x3;}' unless defined(&MMU_CACHE_VIRT);
    eval 'sub MMU_CACHE_PHYS () {0x2;}' unless defined(&MMU_CACHE_PHYS);
    eval 'sub MMU_CACHE_NONE () {0x;}' unless defined(&MMU_CACHE_NONE);
    eval 'sub IOPTE_PPN_MASK () {0x7ffff00;}' unless defined(&IOPTE_PPN_MASK);
    eval 'sub IOPTE_PPN_SHIFT () {8;}' unless defined(&IOPTE_PPN_SHIFT);
    eval 'sub IOPTE_RSVD () {0xf1;}' unless defined(&IOPTE_RSVD);
    eval 'sub IOPTE_WRITE () {0x4;}' unless defined(&IOPTE_WRITE);
    eval 'sub IOPTE_VALID () {0x2;}' unless defined(&IOPTE_VALID);
    eval 'sub NBPRG () {(1<< 24);}' unless defined(&NBPRG);
    eval 'sub RGSHIFT () {24;}' unless defined(&RGSHIFT);
    eval 'sub NSEGRG () {( &NBPRG /  &NBPSG);}' unless defined(&NSEGRG);
    eval 'sub NBPSG () {(1<< 18);}' unless defined(&NBPSG);
    eval 'sub SGSHIFT () {18;}' unless defined(&SGSHIFT);
    eval 'sub PG_V () {0x80000000;}' unless defined(&PG_V);
    eval 'sub PG_PFNUM () {0x7ffff;}' unless defined(&PG_PFNUM);
    eval 'sub VA_VREG {
        my($va) = @_;
	    eval q(((($va) >>  &RGSHIFT) & 255));
    }' unless defined(&VA_VREG);
    eval 'sub VA_VSEG {
        my($va) = @_;
	    eval q(((($va) >>  &SGSHIFT) & 63));
    }' unless defined(&VA_VSEG);
    unless(defined(&_LOCORE)) {
    }
    eval 'sub SRMMU_TETYPE () {0x3;}' unless defined(&SRMMU_TETYPE);
    eval 'sub SRMMU_TEPTE () {0x2;}' unless defined(&SRMMU_TEPTE);
    eval 'sub SRMMU_PPNMASK () {0xffffff00;}' unless defined(&SRMMU_PPNMASK);
    eval 'sub SRMMU_PPNPASHIFT () {0x4;}' unless defined(&SRMMU_PPNPASHIFT);
}
1;
